#include "library.h"

namespace py = pybind11;

void define_building_placer(py::module & m)
{
    py::class_<BuildingPlacer>(m, "BuildingPlacer")
        .def("can_build_here", &BuildingPlacer::canBuildHere, "x"_a, "y"_a, "unit_type"_a)
        .def("can_build_here_with_spaces", &BuildingPlacer::canBuildHereWithSpace, "x"_a, "y"_a, "unit_type"_a, "build_distance"_a)
        .def("get_build_location_near", &BuildingPlacer::getBuildLocationNear, "point2di"_a, "unit_type"_a, "build_distance"_a)
        .def("reserve_tiles", &BuildingPlacer::reserveTiles, "x"_a, "y"_a, "width"_a, "height"_a)
        .def("free_tiles", &BuildingPlacer::freeTiles, "x"_a, "y"_a, "width"_a, "height"_a);
        // TODO: Update this method to find refinery positions outside the first base
        //.def("get_refinery_position", &BuildingPlacer::getRefineryPosition);
}